package managed.beans;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Locale;
import java.util.Random;
import java.util.ResourceBundle;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.servlet.http.HttpSession;

@ManagedBean(name = "UserNumberBean")
@SessionScoped
public class UserNumberBean implements Serializable {

	private static final String BG = "BG";

	private static final long serialVersionUID = 1L;

	private Integer randomInt;
	private Integer userNumber;
	private long maximum = 10;
	private long minimum = 0;

	private String locale;

	private static ArrayList<SelectItem> locales = null;

	/** Creates a new instance of UserNumberBean */
	public UserNumberBean() {
		Random randomGR = new Random();
		randomInt = new Integer(randomGR.nextInt(10));
		System.out.println("Duke's number: " + randomInt);
		
		
	}

	public Integer getUserNumber() {
		return userNumber;
	}

	public void setUserNumber(Integer userNumber) {
		this.userNumber = userNumber;
	}

	public long getMaximum() {
		return (this.maximum);
	}

	public void setMaximum(long maximum) {
		this.maximum = maximum;
	}

	public long getMinimum() {
		return (this.minimum);
	}

	public void setMinimum(long minimum) {
		this.minimum = minimum;
	}

	public String getLocale() {
		return locale;
	}

	public void setLocale(String locale) {
		this.locale = locale;
	}

	public String getResponse() {
		FacesContext context = FacesContext.getCurrentInstance();
		HttpSession session = (HttpSession) context.getExternalContext().getSession(false);
		ResourceBundle messages = null;
		if(null != this.locale){
			messages = ResourceBundle.getBundle("i18n.messages", new Locale(this.locale));
		}else{
			messages = ResourceBundle.getBundle("i18n.messages");
		}
		
			
		if ((userNumber != null) && (userNumber.compareTo(randomInt) == 0)) {
			session.invalidate();
			return messages.getString("yes");
		} else {
			// including HTML requires that you set escape="false" in view
			return  "<p>"+ messages.getString("sorry1")  + userNumber + messages.getString("sorry2") + "</p><p>"+ messages.getString("sorry3") +"</p>";
		}
	}
	
	// available locales
	public Collection<SelectItem> getLocales() {
		if (locales == null) {
			locales = new ArrayList<SelectItem>();

			FacesContext context = FacesContext.getCurrentInstance();
			Iterator<Locale> iSupportedLocales = context.getApplication()
					.getSupportedLocales();
			while (iSupportedLocales.hasNext()) {
				locales.add(new SelectItem(iSupportedLocales.next()
						.getLanguage()));
			}
		}
		return locales;
	}

	public void localeChanged(ValueChangeEvent event) {
		FacesContext context = FacesContext.getCurrentInstance();
		if (BG.equalsIgnoreCase((String) event.getNewValue())) {
			context.getViewRoot().setLocale(new Locale("bg", BG));
		} else {
			context.getViewRoot().setLocale(Locale.ENGLISH);
		}
	}

}
